// 
//
// IwGame - Cross Platform Multi-purpose Game Engine using the Marmalade SDK
//
// Developed by Matthew Hopwood of Pocketeers Limited - www.pocketeers.co.uk
//
// For updates, tutorials and more details check out my blog at www.drmop.com
//
// This code is provided free of charge and without any warranty whatsoever. The only restriction to its usage is that this header must remain intact and visible in all IwGame engine files.
// If you use this engine in your product, whilst it is not mandatory, a mention of the IwGame engine would be nice or a quick email to let us know where it is being used.
//
//

#include "IwGameXoml.h"
#include "IwGameUtil.h"
#include "IwGameString.h"
#include "IwGame.h"
#include "IwGameScene.h"
#include "IwGameActor.h"
#include "IwGameAnim.h"


unsigned int CIwGameXomlNames::Game_Hash					= CIwGameString::CalculateHash("Game");
unsigned int CIwGameXomlNames::Scene_Hash					= CIwGameString::CalculateHash("Scene");
unsigned int CIwGameXomlNames::Actor_Hash					= CIwGameString::CalculateHash("Actor");
unsigned int CIwGameXomlNames::ActorImage_Hash				= CIwGameString::CalculateHash("ActorImage");
unsigned int CIwGameXomlNames::ResourceGroup_Hash			= CIwGameString::CalculateHash("ResourceGroup");
unsigned int CIwGameXomlNames::Animation_Hash				= CIwGameString::CalculateHash("Animation");
unsigned int CIwGameXomlNames::AnimationCollection_Hash		= CIwGameString::CalculateHash("AnimationCollection");

unsigned int CIwGameXomlNames::Name_Hash					= CIwGameString::CalculateHash("Name");
unsigned int CIwGameXomlNames::Current_Hash					= CIwGameString::CalculateHash("Current");
unsigned int CIwGameXomlNames::CanvasSize_Hash				= CIwGameString::CalculateHash("CanvasSize");
unsigned int CIwGameXomlNames::FixAspect_Hash				= CIwGameString::CalculateHash("FixAspect");
unsigned int CIwGameXomlNames::LockWidth_Hash				= CIwGameString::CalculateHash("LockWidth");
unsigned int CIwGameXomlNames::Extents_Hash					= CIwGameString::CalculateHash("Extents");
unsigned int CIwGameXomlNames::AllowSuspend_Hash			= CIwGameString::CalculateHash("AllowSuspend");
unsigned int CIwGameXomlNames::Clipping_Hash				= CIwGameString::CalculateHash("Clipping");
unsigned int CIwGameXomlNames::Active_Hash					= CIwGameString::CalculateHash("Active");
unsigned int CIwGameXomlNames::Visible_Hash					= CIwGameString::CalculateHash("Visible");
unsigned int CIwGameXomlNames::Layers_Hash					= CIwGameString::CalculateHash("Layers");
unsigned int CIwGameXomlNames::Colliders_Hash				= CIwGameString::CalculateHash("Colliders");
unsigned int CIwGameXomlNames::Type_Hash					= CIwGameString::CalculateHash("Type");
unsigned int CIwGameXomlNames::Position_Hash				= CIwGameString::CalculateHash("Position");
unsigned int CIwGameXomlNames::Velocity_Hash				= CIwGameString::CalculateHash("Velocity");
unsigned int CIwGameXomlNames::VelocityDamping_Hash			= CIwGameString::CalculateHash("VelocityDamping");
unsigned int CIwGameXomlNames::Angle_Hash					= CIwGameString::CalculateHash("Angle");
unsigned int CIwGameXomlNames::AngularVelocity_Hash			= CIwGameString::CalculateHash("AngularVelocity");
unsigned int CIwGameXomlNames::AngularVelocityDamping_Hash	= CIwGameString::CalculateHash("AngularVelocityDamping");
unsigned int CIwGameXomlNames::Scale_Hash					= CIwGameString::CalculateHash("Scale");
unsigned int CIwGameXomlNames::Colour_Hash					= CIwGameString::CalculateHash("Colour");
unsigned int CIwGameXomlNames::Layer_Hash					= CIwGameString::CalculateHash("Layer");
unsigned int CIwGameXomlNames::Collidable_Hash				= CIwGameString::CalculateHash("Collidable");
unsigned int CIwGameXomlNames::CollisionSize_Hash			= CIwGameString::CalculateHash("CollisionSize");
unsigned int CIwGameXomlNames::CollisionRect_Hash			= CIwGameString::CalculateHash("CollisionRect");
unsigned int CIwGameXomlNames::WrapPosition_Hash			= CIwGameString::CalculateHash("WrapPosition");
unsigned int CIwGameXomlNames::Image_Hash					= CIwGameString::CalculateHash("Image");
unsigned int CIwGameXomlNames::Size_Hash					= CIwGameString::CalculateHash("Size");
unsigned int CIwGameXomlNames::GroupFile_Hash				= CIwGameString::CalculateHash("GroupFile");
unsigned int CIwGameXomlNames::Frame_Hash					= CIwGameString::CalculateHash("Frame");
unsigned int CIwGameXomlNames::Value_Hash					= CIwGameString::CalculateHash("Value");
unsigned int CIwGameXomlNames::Time_Hash					= CIwGameString::CalculateHash("Time");
unsigned int CIwGameXomlNames::Repeat_Hash					= CIwGameString::CalculateHash("Repeat");
unsigned int CIwGameXomlNames::Duration_Hash				= CIwGameString::CalculateHash("Duration");
unsigned int CIwGameXomlNames::SrcRect_Hash					= CIwGameString::CalculateHash("SrcRect");
unsigned int CIwGameXomlNames::Location_Hash				= CIwGameString::CalculateHash("Location");
unsigned int CIwGameXomlNames::Resource_Hash				= CIwGameString::CalculateHash("Resource");
unsigned int CIwGameXomlNames::Preload_Hash					= CIwGameString::CalculateHash("Preload");
unsigned int CIwGameXomlNames::Blocking_Hash				= CIwGameString::CalculateHash("Blocking");
unsigned int CIwGameXomlNames::AutoPlay_Hash				= CIwGameString::CalculateHash("AutoPlay");
unsigned int CIwGameXomlNames::Anim_Hash					= CIwGameString::CalculateHash("Anim");
unsigned int CIwGameXomlNames::StartAtTime_Hash				= CIwGameString::CalculateHash("StartAtTime");
unsigned int CIwGameXomlNames::Target_Hash					= CIwGameString::CalculateHash("Target");
unsigned int CIwGameXomlNames::Timeline_Hash				= CIwGameString::CalculateHash("Timeline");

unsigned int CIwGameXomlNames::Bool_Hash					= CIwGameString::CalculateHash("bool");
unsigned int CIwGameXomlNames::Float_Hash					= CIwGameString::CalculateHash("float");
unsigned int CIwGameXomlNames::Vec2_Hash					= CIwGameString::CalculateHash("vec2");
unsigned int CIwGameXomlNames::Vec3_Hash					= CIwGameString::CalculateHash("vec3");
unsigned int CIwGameXomlNames::Vec4_Hash					= CIwGameString::CalculateHash("vec4");
unsigned int CIwGameXomlNames::Rect_Hash					= CIwGameString::CalculateHash("rect");
unsigned int CIwGameXomlNames::String_Hash					= CIwGameString::CalculateHash("string");

// 
// Other names
// 


//
// 
// 
//
// CIwGameXoml Implementation
// 
// 
// 
//
CDECLARE_SINGLETON(CIwGameXoml)

void CIwGameXoml::Init()
{
	// Add some basic classes to the XOML engine
	addClass(new CIwGameCreator());					// CIwGame object
	addClass(new CIwGameResourceGroupCreator());	// CIwGameResourceGroup object 
	addClass(new CIwGameSceneCreator());			// CIwGameScene object 
	addClass(new CIwGameAnimCreator());				// CIwGameAnim object 
	addClass(new CIwGameImageCreator());			// CIwGameImage object 
	addClass(new CIwGameAnimTimelineCreator());		// CIwGameAnimTimeline object 

}

void CIwGameXoml::Release()
{
	// Clean up class creators
	for (_Iterator it = begin(); it != end(); ++it)
	{
		delete *it;
	}
	ClassCreators.clear();
}

bool CIwGameXoml::Process(IIwGameXomlResource* parent, const char* filename)
{
	CIwGameXmlParser::PoolsReset();
	CIwGameXmlParser*	xml = new CIwGameXmlParser();

	// Load and parse the xml file
	if (xml->Parse(filename) == eXMLParserError_None)
	{
		// Process the XOML data
		bool error = Process(parent, xml->GetRoot()->GetFirstNode());
		delete xml;
		return error;
	}

	delete xml;
	return false;
}

bool CIwGameXoml::Process(IIwGameXomlResource* parent, CIwGameXmlNode* node)
{
	for (CIwGameXmlNode::_Iterator it = node->begin(); it != node->end(); it++)
	{
		unsigned int name_hash = (*it)->GetName().getHash();

		// Check to see if we support the class
		for (_Iterator it2 = begin(); it2 != end(); ++it2)
		{
			if ((*it2)->getClassNameHash() == name_hash)
			{
				// We do support the class so call the classes creator to instantiate it
				IIwGameXomlResource* instance = (*it2)->CreateInstance(parent);
				if (instance != NULL)
				{
					if (!instance->LoadFromXoml(parent, true, *it))
					{
						delete instance;
						CIwGameError::LogError("Error: Near XOML tag ", (*it)->GetName().c_str());
						return false;
					}
				}
				else
				{
					CIwGameError::LogError("Error: No XOML creator present for ", (*it)->GetName().c_str());
					return false;
				}
				break;
			}
		}
	}

	return true;
}

